//
//  NeoFinderAIProtocol
//  NeoFinder
//
//  Created by norbert doerner2 on 03.08.18.
//  Copyright © 2018 West-Forest-Sytems. All rights reserved.
//


// protocol for NeoFinder AI AutoTag Plugins
// we want to place them in a bundle so they don't blow up the size of the original download, and so that we can replace and extend them

#define kCurrentPluginVersion		7

@protocol NeoFinderAIProtocol

// set up all that needs to be setup
- (int)setupEngine;

- (NSString *_Nonnull)engineNameForDisplay;

- (int)pluginVersion;	// the version of this protocoll that the bundle was compiled for. MUST be larger or equal to kCurrentPluginVersion!! If it is smaller, then we cannot run the Plugin!

// can this bundle run in this hardware and software?
- (BOOL)canRun;

- (void)prepareTagList;

- (NSArray *_Nullable)listOfSupportedTags;	// a list of NSStrings: all the Tags that this engine can recognize. Localized! Can be used for GUI things

- (void)prepareDetectionEngine;

// the best size of the input picture that the engine needs
- (NSSize)sizeNeededForPixBuffers;

// return all tags and their probabilities. Keys in the resulting Dict are the tag names
- (NSDictionary *_Nullable)tagsForImage:(CVPixelBufferRef _Nonnull)theImagePixBuffer error:(NSError * _Nullable * _Nullable)error;

- (void)shutDownDetectorEngine;

@end
